import es
import cfglib
import playerlib
import popuplib
import gamethread
import services
import votelib
import random
import os
from sqlite3 import dbapi2 as sqlite 

info = es.AddonInfo()
info['name'] = "Donator"
info['basename'] = "donator"
info['version'] = "1.2"
info['author'] = "Undead"
info['url'] = "http://forums.mattie.info/cs/forums/viewtopic.php?t=30208"
info['description'] = "Special Privileges Toward Donators"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

gamedir = str(es.ServerVar('eventscripts_gamedir'))
dcfg = cfglib.AddonCFG(gamedir + "/cfg/donator_config/config.cfg")
dcost = dcfg.cvar('Cost_Message', "It cost $5 per month.", 'Cost Message in Donator Info Menu')
dpurch = dcfg.cvar('Purchase_Message', "Visit http://my-website.com for more information.", 'Purchase Message in Donator Info Menu')
dadminplugin = dcfg.cvar('Admin_Plguin', "ma", 'ma = Mani Admin Plugin OR sm = SourceMod Admin Plugin')
dmapsetting = dcfg.cvar('Map_List_Setting', "1", '1 = Use maps from Map_List, 2 = Use maps from maplist.txt')
dmaplist = dcfg.cvar('Map_List', "de_dust2,de_dust,cs_office", 'Map List donators can use to trigger a map vote.')
dtime = dcfg.cvar('Ban_Time', "5", 'How long they are banned when vote banned')
drespawn = dcfg.cvar('Instant_Respawn', "0", '1 = On, 0 = off : Allows Instant Respawning For Gamemodes such as TF2 Deathmatch')
drespawnmod = dcfg.cvar('Respawn_Mod', "spe", 'Only if Instant_Respawn is "1", spe = Source Python Extensions and est = ES_Tools, es = es.spawnplayer for OrangeBox, nt = NativeTools')
dautob = dcfg.cvar('Auto_Balance', "0", '1 = On, 0 = Off : Enables Auto Team Balance')
dautobc = dcfg.cvar('Auto_Balance_Count', "2", '# of player difference between the 2 teams')
dspawnhp = dcfg.cvar('Spawn_Health', "0", '0 = Disabled. How much health donators receive when they spawn')
dspawnarmor = dcfg.cvar('Spawn_Armor', "0", '0 = Disabled. How much armor donators receive when they spawn')
dspawncash = dcfg.cvar('CSS_Spawn_Cash', "0", 'How much money is given to them when they spawn')
dextrateritems = dcfg.cvar('Extra_Terrorist_Items', "", 'Extra items to spawn with for Terrorist. e.g. "hegrenade,flashbang"')
dextractitems = dcfg.cvar('Extra_Counter_Terrorist_Items', "", 'Extra items to spawn with for Counter-Terrorist. e.g. "defuser,hegrenade"')
dreserved = dcfg.cvar('Reserved_Enable', "0", '1 = On, 0 = Off: Enables Reserved Slots for Donators')
drslots = dcfg.cvar('Reserved_Slots', "2", 'Number of slots to keep open for Donators (If Enabled)')
dcfg.write()

dextrateritemslist = str(dextrateritems).split(',')
dextractitemslist = str(dextractitems).split(',')
drespawnmod.addFlag('notify')

isAuthed = lambda userid: False
isAdmin = lambda userid: False

map_list = []
if dmapsetting == '1':
  map_list = map(lambda x: x.strip(), str(dmaplist).split(","))
elif dmapsetting == '2':
  a = open(gamedir + '/maplist.txt')
  for maps in a:
    map_list.append(maps)
  a.close()
t_models_dir = '/cfg/donator_config/t_models.txt'
ct_models_dir = '/cfg/donator_config/ct_models.txt'
voteMap = 0
voteKick = 0
voteBan = 0
voteMute = 0
dict_model = {}

class connection(object):
  def __init__(self,path):
    self.con = sqlite.connect(path)
    self.cur = self.con.cursor()
  def execute(self,sql):
    self.cur.execute(sql)
    self.con.commit()
  def query(self,sql):
    self.cur.execute(sql)
    return self.cur.fetchall()
  def close(self):
    self.con.close()
db = connection(es.getAddonPath('examples/auth/group_auth') + '/es_group_auth.sqldb') 

def utfcode(value):
  """ converts value into utf-8 coded string if it is unicode, otherwise returns the value itself """
  if type(value).__name__ == 'unicode':
    return value.encode('utf-8')
  return value

def convertQuery(result):
  """ converts all unicode strings in a full SQLite query result to utf-8 string objects """
  newresult = list()
  for row in result:
    newrow = [utfcode(item) for item in row]
    newresult.append(newrow)
  return newresult 

def load():
  global dadminplugin, isAuthed, isAdmin
  dcfg.execute()
  es.loadevents('declare', 'addons/eventscripts/donator/donatorevents.res')
  es.addons.registerSayFilter(sayFilter)
  if services.isRegistered('auth'):
    auth = services.use('auth')
    auth.registerCapability('daccess', auth.POWERUSER)
    auth.registerCapability('dadmin', auth.ADMIN)
    isAuthed = lambda userid: auth.isUseridAuthorized(userid, 'daccess')
    isAdmin = lambda userid: auth.isUseridAuthorized(userid, 'dadmin')
    es.dbgmsg(0, 'Auth Enabled')
  else:
    es.dbgmsg(0, 'Please read Installation and Setup your Auth System!')
    es.unload('donator')
  if int(drespawn) == 1: 
    if drespawnmod not in ('spe','est','es','nt'):
      es.dbgmsg(0, 'Invalid Respawn Mod: %s'%drespawnmod)
      es.dbgmsg(0, '\'spe\' or \'est\' or \'es\' or \'nt\' Only!')
      es.dbgmsg(0, 'Fix in config.cfg')
      es.unload('donator')
    else:
      if drespawnmod == 'spe':
        from spe.games import cstrike
        global cstrike
      elif drespawnmod == 'nt':
        import nativetools as nt
        global nt
  if dadminplugin not in ('ma','sm'):
    es.dbgmsg(0, 'Invalid Admin_Plugin CVAR: %s'%dadminplugin)
    es.dbgmsg(0, '\'ma\' or \'sm\' Only!')
    es.dbgmsg(0, 'Fix in config.cfg')
    es.unload('donator')
  if not es.exists('saycommand', '!dmenu'):
    es.regsaycmd('!dmenu', 'donator/dmenu_cmd')
  if not es.exists('saycommand', '!donators'):
    es.regsaycmd('!donators', 'donator/donators_cmd')
  if not es.exists('saycommand', '!imenu'):
    es.regsaycmd('!imenu', 'donator/imenu_cmd')
  if not es.exists('saycommand', '!dadmin'):
    es.regsaycmd('!dadmin', 'donator/dadmin_cmd')
  dadminm = popuplib.easymenu('dadminm', '_popup_choice', dadminm_select)
  dadminm.settitle("Admin Donator Menu")
  dadminm.addoption('1', "Add a Donator")
  dadminm.addoption('2', "Delete a Donator")
  dadminm.addoption('3', "Broadcast Advert")
  dmenu = popuplib.easymenu('dmenu', '_popup_choice', dmenu_select)
  dmenu.settitle("Donator Menu")
  dmenu.addoption('1', "Swap Teams")
  dmenu.addoption('2', "Start Vote Kick")
  dmenu.addoption('3', "Start Vote Ban")
  dmenu.addoption('4', "Start Vote Mute")
  dmenu.addoption('5', "Start Map Vote")
  dmenu.addoption('6', "Go To Spectate")
  if os.path.isfile(gamedir + t_models_dir) and os.path.isfile(gamedir + ct_models_dir):
    dmenu.addoption('7', "Change Model")
  imenu = popuplib.easymenu('imenu', '_popup_choice', imenu_select)
  imenu.settitle("Donator Information")
  imenu.addoption('1', "How Much?")
  imenu.addoption('2', "How to Purchase?")
  for users in es.getUseridList():
    if isAuthed(users):
      if users not in dict_model:
        dict_model[int(users)] = {'model': None}
  add_downloads()
  es.dbgmsg(0, 'Map Vote List: %s'%map_list)
  es.msg('#multi', '#default[#greenDonator#default] by #lightgreenUndead #defaulthas been loaded!')

def unload():
  es.addons.unregisterSayFilter(sayFilter)
  if es.exists('saycommand', '!dmenu'):
    es.unregsaycmd('!dmenu')
  if es.exists('saycommand', '!donators'):
    es.unregsaycmd('!donators')
  if es.exists('saycommand', '!dadmin'):
    es.unregsaycmd('!dadmin')
  if popuplib.exists('dmenu'):
    popuplib.delete('dmenu')
  if popuplib.exists('plist'):
    popuplib.delete('plist')
  if popuplib.exists('plist2'):
    popuplib.delete('plist2')
  if popuplib.exists('plist3'):
    popuplib.delete('plist3')
  if popuplib.exists('mlist'):
    popuplib.delete('mlist')
  if popuplib.exists('dadminm'):
    popuplib.delete('dadminm')
  es.msg('#multi', '#default[#greenDonator#default] by #lightgreenUndead #defaulthas been unloaded!')

def dmenu_cmd():
  user = es.getcmduserid()
  if isAuthed(user):
    popuplib.send('dmenu', user)
  else:
    es.tell(user, 'You must be a donator to use this command.')

def dadmin_cmd():
  user = es.getcmduserid()
  if isAdmin(user):
    popuplib.send('dadminm', user)
  else:
    es.tell(user, 'You do not have access to this command.')

def imenu_cmd():
  user = es.getcmduserid()
  if not isAuthed(user):
    popuplib.send('imenu', user)
  else:
    es.tell(user, 'You are already a Donator!')

def donators_cmd():
  userid = es.getcmduserid()
  users = db.query("SELECT ALL Name FROM vwPlayersGroups WHERE GroupName='Donators'")
  if users:
    donators_menu = popuplib.create('donators_menu')
    donators_menu.addline('Current Donators:')
    for user in users:
      donators_menu.addline(utfcode(user[0]))
    donators_menu.send(userid)
  else:
    es.tell(userid, 'No current Donators at the moment')

def donator_chat(ev):
  if ev['teamonly'] == '1':
    for x in es.getUseridList():
      if es.getplayerteam(x) == es.getplayerteam(ev['userid']):
        es.tell(x, '#multi', '#default(TEAM) #green%s : #default%s'%(ev['username'],ev['text']))
  else:
    es.msg('#multi', '#green%s : #default%s'%(ev['username'],ev['text']))

def sayFilter(userid, text, teamonly):
  if userid == -1: return userid, text, teamonly
  if isAuthed(userid) or isAdmin(userid):
    first_word = text.split(' ')[0].strip('"')
    if es.exists('saycommand', first_word):
      return userid, text, teamonly
    if first_word.startswith('.') and not first_word.startswith('..'):
      return userid, text.replace('.', ''), teamonly
    if text[0] == text[~0] == '"':
      newtext = text[1:~0]
      username = es.getplayername(userid)
      es.event('initialize', 'donator_chat')
      es.event('setstring', 'donator_chat', 'text', str(newtext))
      es.event('setstring', 'donator_chat', 'username', username)
      if not teamonly:
        teamchat = 0
        es.event('setstring', 'donator_chat', 'teamonly', teamchat)
      else:
        teamchat = 1
        es.event('setstring', 'donator_chat', 'teamonly', teamchat)
      es.event('setstring', 'donator_chat', 'userid', userid)
      es.event('fire', 'donator_chat')
      return 0, None, None
  return userid, text, teamonly

def es_map_start(ev):
  add_downloads()
  es.loadevents('addons/eventscripts/donator/donatorevents.res')

def add_downloads():
  filepath = gamedir + '/cfg/donator_config/downloads.cfg'
  directory = str(es.ServerVar('eventscripts_gamedir')) + '/'
  if os.path.isfile(filepath):
    folders = filter(lambda x: x.replace(' ', '') and not x.startswith('//'), open(filepath).read().split('\n'))
    for folder in folders:
      for fp in os.listdir(directory + 'models/' + folder):
        es.stringtable('downloadables', 'models/' + folder + fp)
      for fp in os.listdir(directory + 'materials/models/' + folder):
        es.stringtable('downloadables', 'materials/models/' + folder + fp)

def server_cvar(ev):
  if int(drespawn) == 1:
    if ev['cvarname'] == 'Respawn_Mod':
      if ev['cvarvalue'] == 'spe':
        from spe.games import cstrike
        global cstrike
      elif ev['cvarvalue'] == 'nt':
        import nativetools as nt
        global nt

def player_activate(ev):
  userid = int(ev['userid'])
  if int(dreserved) == 1:
    check_player(userid)
  if isAuthed(userid):
    es.msg('#multi', 'Donator #green%s #defaulthas joined!'%es.getplayername(userid))
    if userid not in dict_model:
      dict_model[userid] = {'model': None}

def check_player(userid):
  difference = int(es.getmaxplayercount()) - int(es.getplayercount())
  if int(drslots) >= difference:
    if returnReservedStatus(userid):
      random_kick()
    else:
      es.server.queuecmd('kickid %s Reserved Slot'%userid)

def returnReservedStatus(userid):
  if isAuthed(userid):
    return True
  else:
    return False

def random_kick():
  random_player = random.choice(playerlib.getUseridList('#human'))
  if not isAuthed(random_player):
    es.server.queuecmd('kickid %s Reseved Slot'%random_player)
  else:
    random_kick()

def player_spawn(ev):
  user = int(ev['userid'])
  if isAuthed(user):
    player = playerlib.getPlayer(user)
    if int(dspawnhp) > 0:
      player.health = int(dspawnhp)
    if int(dspawnarmor) > 0:
      player.armor = int(dspawnarmor)
    if es.getgame() == "Counter-Strike: Source":
      if int(dspawncash) > 0:
        player.cash = int(dspawncash)
    if ev['es_userteam'] == '2':
      for x in dextrateritemslist:
        if x:
          es.server.queuecmd('es_give %s weapon_%s'%(user,x))
    elif ev['es_userteam'] == '3':
      for x in dextractitemslist:
        if x:
          es.server.queuecmd('es_give %s weapon_%s'%(user,x))
  if user in dict_model:
    if dict_model[user]["model"] != None:
      player.model = dict_model[user]["model"]

def player_death(ev):
  if int(drespawn) == 1:
    user = ev['userid']
    if isAuthed(user):
      if drespawnmod == 'spe':
        cstrike.respawn(user)
      elif drespawnmod == 'est':
        es.server.queuecmd('est_Spawn %s'%user)
      elif drespawnmod == 'es':
        es.spawnplayer(user)
      elif drespawnmod == 'nt':
        nt.spawnPlayer(user)

def player_team(ev):
  userid = int(ev['userid'])
  if int(dautob) == 1:
    team1 = es.getplayercount(2)
    team2 = es.getplayercount(3)
    auto_balance(team1, team2)
  if userid in dict_model:
    if ev['team'] != ev['oldteam']:
      dict_model[userid]["model"] = None

def auto_balance(team1, team2):
  if (team1 - int(dautobc)) > team2 or (team2 - int(dautobc)) > team1:
    rand_player = random.choice(es.getUseridList())
    if isAuthed(rand_player):
      auto_balance(team1, team2)
    elif es.getplayerteam(rand_player) == 1:
        auto_balance(team1, team2)
    else:
      if es.getplayerteam(rand_player) == 2:
        es.changeteam(rand_player, 3)
      elif es.getplayerteam(rand_player) == 3:
        es.changeteam(rand_player, 2)

def dadminm_select(userid, choice, popupid):
  if choice == '1':
    plist4 = popuplib.easymenu('plist4', '_popup_choice', plist4_select)
    plist4.settitle("Add Player:")
    for players in es.getUseridList():
      if not isAuthed(players):
        plist4.addoption(players, es.getplayername(players))
    plist4.send(userid)
  elif choice == '2':
    plist5 = popuplib.easymenu('plist5', '_popup_choice', plist5_select)
    plist5.settitle("Delete Player:")
    for players in es.getUseridList():
      if isAuthed(players):
        if players != userid:
          plist5.addoption(players, es.getplayername(players))
    plist5.send(userid)
  elif choice == '3':
    for players in es.getUseridList():
      if not isAuthed(players):
        es.tell(players, '#multi', '#default[#greenDonator#default]: Type #lightgreen!imenu #defaultfor Information on Donating!')

def imenu_select(userid, choice, popupid):
  if choice == '1':
    es.tell(userid, dcost)
  elif choice == '2':
    es.tell(userid, dpurch)

def dmenu_select(userid, choice, popupid):
  if choice == '1':
    team = es.getplayerteam(userid)
    if team == 1:
      rand_team = random.randint(2, 3)
      es.changeteam(userid,str(rand_team))
    elif team == 2:
      es.changeteam(userid,'3')
    elif team == 3:
      es.changeteam(userid,'2')
  elif choice == '2':
    plist = popuplib.easymenu('plist', '_popup_choice', plist_select)
    plist.settitle("Select Player:")
    for players in playerlib.getUseridList('#human'):
      if not isAuthed(players):
        plist.addoption(players, es.getplayername(players))
    plist.send(userid)
  elif choice == '3':
    plist2 = popuplib.easymenu('plist2', '_popup_choice', plist2_select)
    plist2.settitle("Select Player:")
    for players in playerlib.getUseridList('#human'):
      if not isAuthed(players):
        plist2.addoption(players, es.getplayername(players))
    plist2.send(userid)
  elif choice == '4':
    plist3 = popuplib.easymenu('plist3', '_popup_choice', plist3_select)
    plist3.settitle("Select Player:")
    for players in playerlib.getUseridList('#human'):
      if not isAuthed(players):
        plist3.addoption(players, es.getplayername(players))
    plist3.send(userid)
  elif choice == '5':
    mlist = popuplib.easymenu('mlist', '_popup_choice', mlist_select)
    mlist.settitle("Select Map:")
    for maps in map_list:
      mlist.addoption(maps, maps)
    mlist.send(userid)
  elif choice == '6':
    es.changeteam(userid,'1')
  elif choice == '7':
    model_menu = popuplib.easymenu('model_menu', '_popup_choice', model_menuselect)
    model_menu.settitle("Select a Model:")
    if es.getplayerteam(userid) == 2:
      if os.path.isfile(gamedir + t_models_dir):
        a = open(gamedir + t_models_dir, 'r')
        for line in a:
          newline = str(line).replace('\n','').split(' ')
          model_menu.addoption(newline[1].replace("'", ""), newline[0].strip("',"))
        a.close()
    elif es.getplayerteam(userid) == 3:
      if os.path.isfile(gamedir + ct_models_dir):
        a = open(gamedir + ct_models_dir, 'r')
        for line in a:
          newline = str(line).replace('\n','').split(' ')
          model_menu.addoption(newline[1].replace("'", ""), newline[0].strip("',"))
        a.close()
    model_menu.send(userid)

def model_menuselect(userid, choice, popupid):
  playerlib.getPlayer(userid).setModel(choice)
  if userid in dict_model:
    dict_model[int(userid)]["model"] = choice

def plist_select(userid, choice, popupid):
  global voteKick
  voteKick = votelib.create('%s'%choice, voteKick_end, voteKick_submit)
  voteKick.setquestion('Kick %s?'%es.getplayername(choice))
  voteKick.addoption('No')
  voteKick.addoption('Yes')
  voteKick.start(60)

def voteKick_submit(userid, votename, choice, choicename):
  es.msg('Vote Kick %s - %s selected %s'%(es.getplayername(votename), es.getplayername(userid), choicename))

def voteKick_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Kick %s- Cancelled!'%es.getplayername(votename))
  else:
    if winname == 'Yes':
      es.server.queuecmd('kickid %s Vote Kicked'%votename)
      es.msg('Vote Kick %s - Successful due to majority vote!'%es.getplayername(votename))
    else:
      es.msg('Vote Kick %s - Failed due to majority votes!'%es.getplayername(votename))
  voteKick.delete()

def plist2_select(userid, choice, popupid):
  global voteBan
  voteBan = votelib.create('%s'%choice, voteBan_end, voteBan_submit)
  voteBan.setquestion('Ban %s?'%es.getplayername(choice))
  voteBan.addoption('No')
  voteBan.addoption('Yes')
  voteBan.start(60)

def voteBan_submit(userid, votename, choice, choicename):
  es.msg('Vote Ban %s - %s selected %s'%(es.getplayername(votename), es.getplayername(userid), choicename))

def voteBan_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Vote Ban %s - Cancelled!'%es.getplayername(votename))
  else:
    if winname == 'Yes':
      es.server.queuecmd('banid %s %s'%(dtime, votename))
      es.msg('Vote Ban %s - Successful due to majority vote!'%es.getplayername(votename))
    else:
      es.msg('Vote Ban %s - Failed due to majority votes!'%es.getplayername(votename))
  voteBan.delete()

def plist3_select(userid, choice, popupid):
  global voteMute
  voteMute = votelib.create('%s'%choice, voteMute_end, voteMute_submit)
  voteMute.setquestion('Mute %s?'%es.getplayername(choice))
  voteMute.addoption('No')
  voteMute.addoption('Yes')
  voteMute.start(60)

def voteMute_submit(userid, votename, choice, choicename):
  es.msg('Vote Mute %s - %s selected %s'%(es.getplayername(votename), es.getplayername(userid), choicename))

def voteMute_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Vote Mute %s - Cancelled!'%es.getplayername(votename))
  else:
    if winname == 'Yes':
      es.server.queuecmd('%s_mute %s'%(dadminplugin,votename))
      es.msg('Vote Mute %s - Successful due to majority vote!'%es.getplayername(votename))
    else:
      es.msg('Vote Mute %s - Failed due to majority votes!'%es.getplayername(votename))
  voteMute.delete()

def mlist_select(userid, choice, popupid):
  global voteMap
  voteMap = votelib.create('%s'%choice, voteMap_end, voteMap_submit)
  voteMap.setquestion('Change Map To: %s'%choice)
  voteMap.addoption('No')
  voteMap.addoption('Yes')
  voteMap.start(60)

def voteMap_submit(userid, votename, choice, choicename):
  es.msg('Vote Map %s - %s selected %s'%(votename, es.getplayername(userid), choicename))

def voteMap_end(votename, win, winname, winvotes, winpercent, total, tie, cancelled):
  if cancelled:
    es.msg('Vote Map %s - Cancelled!'%votename)
  else:
    if winname == 'Yes':
      es.server.queuecmd('changelevel %s'%votename)
      es.msg('Vote Map %s - Successful due to majority vote!'%votename)
    else:
      es.msg('Vote Map %s - Failed due to majority votes!'%votename)
  voteMap.delete()

def plist4_select(userid, choice, popupid):
  target_name = es.sql("queryvalue", "SELECT name FROM Players WHERE steamid='%s'"%es.getplayersteamid(choice))
  es.server.queuecmd('gauth user create "%s" "%s"'%(es.getplayername(choice), es.getplayersteamid(choice)))
  es.server.queuecmd('gauth user join "%s" "Donators"'%es.getplayername(choice))
  es.msg('#multi', '#green%s #defaulthas been added to Donators Group!'%es.getplayername(choice))

def plist5_select(userid, choice, popupid):
  target_name = es.sql("queryvalue", "group_auth", "SELECT name FROM Players WHERE steamid='%s'"%es.getplayersteamid(choice))
  es.server.queuecmd('gauth user leave "%s" "Donators"'%target_name)
  es.server.queuecmd('gauth user delete "%s"'%target_name)
  es.msg('#multi', '#green%s #defaulthas been removed from Donators Group!'%es.getplayername(choice))